/*-----------------------------------------------------------------
!	Diese Datei definert die Prototypen und die Datenstrukturen
!	die zum laden und bearbeiten der HTML-Fenster bentigt werden.
+----------------------------------------------------------------*/

#if  !defined( _HTMLWIN_ )
#define _HTMLWIN_

#include <aes.h>

/*===== Variablen ==============================================*/

/*===== Strukturdefinition =====================================*/

typedef struct fenster {
	struct fenster	*next;		/* Zeiger auf die nchste Fensterstruktur	*/
	struct fenster	*before;	/* Zeiger auf die vorige Fensterstruktur	*/

	OBJECT	*ob;				/* Ein Object, das innerhalb des Fensters	*/
								/* dargestellt wird ansonsten NULL			*/

	void	(* exit_ob) (int exit, struct fenster *win);	
								/* Prozedur zum bearbeiten des angehngten Objekts	*/

	char	inf[21];			/* 20 Zeichen fr die Kennung in der INF-Datei	*/
	char	name[81];			/* Maximal 80 Zeichen in der titel!			*/
	char	info[81];			/* Maximal 80 Zeichen in der Infozeile!		*/
	
	int		wind_handle;		/* Window Handle							*/
	int		art;				/* Alle Teile des Fensters					*/

	int		fx;					/* X;Y Koordinaten des Fenster				*/
	int		fy;					/* es gelten die Auenmae des Fensters!	*/
	int		fw;					/* Breite/Hhe d. Fensters					*/
	int		fh;

	int		max_x;				/* Maximal darstellbare Spalten				*/
	int		max_y;				/* Maximal darstellbare Zeilen				*/

	int		aktiv		:1;		/* TRUE, dann ist es geffnet	*/
	int		init		:1;		/* TRUE, wenn Werte gltig		*/
	int		fulled		:1;		/* TRUE, dann wurde fuller bettigt	*/
	
	long	topline;			/* Nr der zu oberst angezeigten txt-Struktur	*/
	long	zeilen_anzahl;		/* Anzahl der gesamten Zeilen					*/

	long	leftpos;			/* Nr der linken Spalte	*/
	long	spalten_anzahl;		/* Spaltenanzahl der lngsten Zeile	*/
	int		ax;					/* X;Y Koordinaten des Arbeitsbereichs des Fensters	*/
	int		ay;					
	int		aw;					/* Arbeitsbereich breite/hhe	*/
	int		ah;
} FENSTER;

/*===== Prototyypendefinitionen ================================*/

FENSTER *create_fenster(char *name, char *info, char *inf, OBJECT *ob);
void schliesse_fenster(FENSTER *win);
void oeffne_fenster(FENSTER *win, int x, int y, int w, int h);
void open_info(FENSTER *win);
FENSTER *oeffne_form(int index, char *titel, char *infoline, char *inf, void (*exit_ob) (int exit, FENSTER *win  ), int px, int py);
void setze_ob(FENSTER *win, int kind, char *text);

#endif
