/*-------------------------------------------------------------------------
!	SEEBAER.C				Version 0.26			     26.10.1997
!
!	Dieses Programm wertet die Log-buch-Datei aus!
+------------------------------------------------------------------------*/

#define TITEL "SEEBR 0.26  " __DATE__
#define INFO_ZEILE "  1997 by Michael Pieper"

#define TRUE 1
#define FALSE 0
#define MIN(x, y) (((x) < (y)) ? (x) : (y))
#define MAX(x, y) (((x) > (y)) ? (x) : (y))

char c_titel[]=TITEL;
char c_text[]=INFO_ZEILE;

#include <aes.h>
#include <ctype.h>
#include <ext.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stddef.h>
#include <time.h>
#include <tos.h>
#include <magx.h>
#include <vdi.h>
#include <new_aes.h>
#include <vaproto.h>
#include <portab.h>		/* wird fr fslx_lib.h bentigt!	*/
#include <fslx_lib.h>

#include "seebaer.h"	/* RSC-Definitionen	*/
#include "log_win.h"	/* Definitionen zu den Fensterfunktionen	*/

FENSTER		*main_window=NULL;	/* Zeiger auf die erste Fensterstruktur		*/
char		proto_file[128];

MFDB	mfdb;

int		ch_w, ch_h;
int		vdi_handle;
int		ap_id;

typedef struct {
	int index;
	int kr;
	int ks;
} MENU_KEY;

MENU_KEY *menu_key;
OBJECT *menu;
OBJECT *copyright;
OBJECT *log_info;
OBJECT *balken;
OBJECT *ob_stat_h;
OBJECT *ob_stat_w;
OBJECT *ob_stat_m;
OBJECT *ob_stat_e;
OBJECT *ob_stat_d;
OBJECT *texte;

typedef struct {
	unsigned hour:5;
	unsigned minute:6;
	unsigned second:5;
	unsigned year:7;
	unsigned month:4;
	unsigned day:5;
} DATETIME;

typedef union {
	DATETIME dati;
	DOSTIME  dost;
} DOSDATE;

typedef struct {
	DATETIME dt;
	char status;		/* 'S' = Start; 'E' = Ende; 'A' = Absturz; 'R`=Resolutionchange 	*/
	char bs; 			/* MiNT='M', N.AES='N', SingleTOS='S', MagiC='C'	*/
} LOG;

#define BS_SUMME 0
#define BS_STOS 1
#define BS_MINT 2
#define BS_MAGX 3
#define BS_NAES 4
#define BS_UNBEK 5	/* Mu der letzte Eintrag der Liste bleiben!!	*/

typedef struct {
	unsigned long wert[BS_UNBEK+1];
	char text[10];
} STATISTIK;

LOG *log = NULL;
long max_log = 0;
long eintraege = 0;

int color;				/* Anzahl der Planes	*/
int	fill_style[BS_UNBEK+1] = { 7, 7, 7, 7, 7, 7 };
int	fill_color[BS_UNBEK+1] = { 2, 2, 2, 2, 2, 2 };
int text_color[BS_UNBEK+1] = { 1, 1, 1, 1, 1, 1 };
int	min_breite = 10;	/* kleiner darf ein Balken nicht werden!	*/

unsigned long messzeit = 0L;

unsigned long stat_h_max[24];	/* Maximale Werte der Stundenstatistik	*/
unsigned long stat_w_max[7];	/* Maximale Werte der Wochenagsstatistik	*/
unsigned long stat_m_max[12];	/* Maximale Werte der Monatsstatistik	*/

typedef struct {
	unsigned long betriebssekunden;

	unsigned long stat_h[24];	/* Stundenstatistik	*/
	unsigned long stat_w[7];	/* Wochenagsstatistik	*/
	unsigned long stat_m[12];	/* Monatsstatistik	*/
	unsigned long stat_e[3];	/* Shutdownsttistik	*/
	unsigned long stat_d[12];	/* Laufzeitstatistik	*/

} BS_STATISTIK;

BS_STATISTIK bs_stat[BS_UNBEK+1];	/* 4 Betriebssysteme!	*/

FENSTER *log_win=NULL;

STATISTIK *stat_ft;		/* fortlaufende Tagesstatistik	*/
unsigned long anz_ft;		/* Anzahl der Eintragungen		*/
FENSTER *ft=NULL;

STATISTIK *stat_fw;		/* fortlaufende Wochenstatistik	*/
unsigned long anz_fw;		/* Anzahl der Eintragungen		*/
FENSTER *fw=NULL;

STATISTIK *stat_fm;		/* fortlaufende Monatsstatistik	*/
unsigned long anz_fm;		/* Anzahl der Eintragungen		*/
FENSTER *fm=NULL;

FENSTER *bds=NULL;		/* Betriebsdauer-Durchschnitt	*/

char *mon[] = {"Jan","Feb","Mr","Apr","Mai","Jun","Jul","Aug","Sep","Okt","Nov","Dez"};
int day_tab[2][13] = {                            /* Zur Berechnung des aktuellen Wochentages ist eine Tabelle ntig, die         */
     {365,31,28,31,30,31,30,31,31,30,31,30,31},   /* Beschreibt welcher Monat wieviel Tage hat. Auerdem steht noch die Anzahl    */
     {366,31,29,31,30,31,30,31,31,30,31,30,31}    /* der Tage im Jahr an erster Stelle. Tab 1 = normales Jahr Tab 2 = Schaltjahr  */
};

/*-------------------------------------------------------------------------
!	Prototypendefinition
+------------------------------------------------------------------------*/

int	appl_anmelden(void);
void appl_abmelden(void);
int message_button(int mx, int my, int mb, int ks);
int rsrc_init(void);

int events(int quit);

void ausgabe_text(int vdi_handle, FENSTER *win, char *text, int *x, int *y);
void speicher_log(void);

int message_katalog(int *buffer);
void draw_inh(FENSTER *akt, GRECT *clip);
void draw_balken(FENSTER *win, STATISTIK *werte, unsigned long anzahl);
void draw_kreis(FENSTER *akt);
int	intersect(GRECT *re_1, GRECT *re_2);
void lade_proto(void);
void setze_statistik(OBJECT *ob);
long diff_time(DATETIME *start, DATETIME *ende, int *stunden, int *minuten);
void setze_log(OBJECT *ob, int nr);
void setze_stat(OBJECT *ob, int kind, int text, int max_x, int max_y, unsigned long *werte, unsigned long *max_werte);
void setze_hstat(int bs, unsigned long sekunden, DATETIME *start_zeit);
void setze_wstat(int bs, unsigned long sekunden, DATETIME *start_zeit);
void setze_mstat(int bs, unsigned long sekunden, DATETIME *start_zeit);

void ende(char *text, char e);
char *intoa(int value, char *string, int laenge);
void lese_inf(void);
void sichern_inf(void);
int get_tage(DATETIME *dt);
long get_sekunden(DATETIME *dt);

void bearbeite_einstellung (int exit, FENSTER *win  );
void close_all_windows(void);

FENSTER *oeffne_balken(char *titel, char *info, char *inf_file, long anzahl, int x, int y, int w, int h);

/*-------------------------------------------------------------------------
!	Das Hauptprogramm
+------------------------------------------------------------------------*/

void main(int argc, char *argv[])

{
	char *c[];

	appl_anmelden();
	
	if (!rsrc_init()) {
		appl_abmelden();
		exit(0);
	}
	shel_envrn(c, "SEEBAER-FILE=");
	
	if (*c != NULL) strcpy(proto_file, *c);
	else strcpy(proto_file, "C:\\SEEBAER.LOG");

	if (argc == 2) strcpy(proto_file, argv[1]);
	lade_proto();
	setze_statistik(copyright);
	lese_inf();
	menu_bar( menu, TRUE );
	graf_mouse(ARROW, 0);
	
	while(!events(FALSE));

	menu_bar( menu, FALSE );
	appl_abmelden();

	exit(0);
}


/*-----------------------------------------------------------------------
!	Meldet das Programm an
!	<- app_id der eigenen Applikation
+----------------------------------------------------------------------*/

int	appl_anmelden(void)

{
	int dummy;
	
	ap_id = appl_init();			/* anmelden	*/
	if (ap_id < 0) {
		form_alert(1, "[3][" TITEL "| | Fehler beim Anmelden!][Abbruch]");
		appl_exit();
		exit(0);
	}

    if (Pdomain(1) >= 0) {		/* Ich kann lange Dateinamen	*/
		shel_write(SHW_MSGREC, 0x0001, 0, NULL, NULL);	/* Ich verstehe AP_TERM	*/
	}
	
	vdi_handle = graf_handle(&ch_w, &ch_h, &dummy, &dummy);

	for ( dummy = 1; dummy < 10; _GemParBlk.intin[dummy++] = 1 );
	_GemParBlk.intin[10] = 1;
	_GemParBlk.intin[0]  = vdi_handle;

	v_opnvwk(_GemParBlk.intin, &vdi_handle, _GemParBlk.intout);
	mfdb.fd_addr = Logbase();
	mfdb.fd_w = _GemParBlk.intout[0] + 1;
	mfdb.fd_h = _GemParBlk.intout[1] + 1;
	mfdb.fd_wdwidth = mfdb.fd_w / 16;
	mfdb.fd_stand = FALSE;
	vq_extnd(vdi_handle, TRUE, _GemParBlk.intout);
	color = mfdb.fd_nplanes = _GemParBlk.intout[4];

	vswr_mode(vdi_handle, MD_REPLACE);

	return(ap_id);
}

/*----------------------------------------------------------------
!	User aktionen
!	Beendet das Programm, wenn Programm beendet werden soll
+-----------------------------------------------------------------*/

int events(int quit)

{
	int erg, kr, br, mx, my, mb, ks, i;
	int buffer[16];
	int art = MU_MESAG|MU_BUTTON|MU_KEYBD;
	
	if (quit) art |= MU_TIMER;

	do {
		erg = evnt_multi(art,
                 2, 1, 1,
                 0, 0, 0, 0, 0,
                 0, 0, 0, 0, 0,
                 buffer,
                 100, 0,  
                 &mx, &my,
                 &mb, &ks,
                 &kr, &br);
        
		if (erg & MU_MESAG) quit |= message_katalog(buffer);
        if (erg & MU_BUTTON) if (br >= 1) quit |= message_button(mx, my, mb, ks);

		if (erg & MU_KEYBD) {
			for (i = 0; menu_key[i].index != -1; i++) {
				if ((menu_key[i].kr == kr) && (menu_key[i].ks == ks || (menu_key[i].ks & 0xfffe) == ks || (menu_key[i].ks & 0xfffd) == ks)) {
					buffer[0] = MN_SELECTED;
					buffer[4] = menu_key[i].index;
					quit |= message_katalog(buffer);
					break;
				}
			}
		}
	} while (!quit);

	return(quit);
}

/*-----------------------------------------------------------------------
!	Meldet das Programm ab
+-----------------------------------------------------------------------*/

void appl_abmelden(void)

{
	if (log != NULL) Mfree(log);
	if (stat_ft != NULL) Mfree(stat_ft);
	if (stat_fw != NULL) Mfree(stat_fw);
	if (stat_fm != NULL) Mfree(stat_fm);
	if (menu_key != NULL) Mfree(menu_key);
	close_all_windows();
	v_clsvwk(vdi_handle);
	appl_exit();
}

/*----------------------------------------------------------------------
!	Schliet alle Fenster
+--------------------------------------------------------------------*/

void close_all_windows(void)

{
	while (main_window != NULL) schliesse_fenster(main_window);
}

/*----------------------------------------------------------------------
!	Initialisiert das RSC-File und die bentigten Fenster
+---------------------------------------------------------------------*/

int rsrc_init(void)

{
	KEYTAB *keytbl;
	int i,j,k;
	char *c, *d;

	if (!rsrc_load("SEEBAER.RSC")) {
		form_alert(1, "[3][Unable to find|SEEBAER.RSC][Cancel]");
		return(FALSE);
	} else {
		rsrc_gaddr(0, MENU, &menu);
		
		keytbl = Keytbl((char *)-1,(char *) -1,(char *) -1);
		for (i = 0; !(menu[i].ob_flags & LASTOB); i++);
		menu_key = malloc(i * sizeof(MENU_KEY));
		if (menu_key != NULL) {
			memset(menu_key, 0, i * sizeof(MENU_KEY));
			i = j = 0;
			do {
				if (menu[i].ob_type == G_STRING) {
					d = menu[i].ob_spec.free_string;
					c = &d[strlen(d)]-1;
					while (c > d && *c == ' ') c--;	/* letzte Leerzeichen berlesen	*/
					if (c-d > 3) {
						if (c[-1] == '^') {
							menu_key[j].ks = 0x0004;
							menu_key[j].kr = *c & 0x1f;
						} else if (c[-1] == '\x07') menu_key[j].ks = 0x0008;
						if (c[-2] == '\x01') menu_key[j].ks |= 0x0003;

						if (menu_key[j].ks != 0) {
						
							menu_key[j].index = i;
				            for (k = 0; k < 128; k++) { /* Scancode setzen	*/
        				        if ((keytbl->unshift[k] == *c) || (keytbl->shift[k] == *c)) { 
                				    menu_key[j].kr |= k << 8; 
		                		    break; 
		        		        } 
        				    }    

							j++;
						}
					}
				}
			} while (!(menu[i++].ob_flags & LASTOB));

			menu_key[j].index = -1;	/* Endemarkierung	*/
		}
		rsrc_gaddr(0, LOG_INFO, &log_info);
		rsrc_gaddr(0, COPYRIGHT, &copyright);
		strcpy(copyright[MEINNAME].ob_spec.free_string, "Michael Pieper");
		strcpy(copyright[STRASSE].ob_spec.free_string, "Flurstr. 5");
		strcpy(copyright[ORT].ob_spec.free_string, "86368 Gersthofen");
		strcpy(copyright[EMAIL].ob_spec.free_string, "eMail: mp@ghf.augusta.de");

/*		if (color < 2) {	*/	/*fhrt leider zu Bomben!*/ /*
			for (i = 0; !(copyright[i].ob_flags & LASTOB); i++) {
				if (copyright[i].ob_type == G_CICON) copyright[i].ob_type = G_ICON;
			}
		}*/

		rsrc_gaddr(0, STAT_H, &ob_stat_h);
		rsrc_gaddr(0, STAT_W, &ob_stat_w);
		rsrc_gaddr(0, STAT_M, &ob_stat_m);
		rsrc_gaddr(0, STAT_ENDE, &ob_stat_e);
		rsrc_gaddr(0, STAT_DAUER, &ob_stat_d);

		rsrc_gaddr(0, EINSTELLUNG, &balken);
		rsrc_gaddr(0, TEXTE, &texte);
	}
	return(TRUE);
}


/*----------------------------------------------------------------
!	Behandelt die Nachrichten 
!	Gibt TRUE zurck, wenn beendet werden soll
+-----------------------------------------------------------------*/

int message_katalog(int *buffer)

{
	int end = FALSE, i, top, left;
	FENSTER *akt;
	GRECT clip;
	
	wind_update(BEG_UPDATE);
	
	if (buffer[0] != MN_SELECTED && buffer[0] != VA_START) i = buffer[3];
	else wind_get(0, WF_TOP, &i);
		
	for (akt = main_window; akt != NULL && akt->wind_handle != i && akt->next != NULL; akt = akt->next);	/* aktuelles Fenster oder oberstes Fenster suchen!	*/

	switch(buffer[0]) {			/* ev_mgpbuff */
		case MN_SELECTED:		/* Men ausgewhlt	*/
			switch(buffer[4]) {
				case MENU_QUIT:
					wind_update(END_UPDATE);
					return(TRUE);
				case MENU_INFO:
					oeffne_form(COPYRIGHT, TITEL, NULL, "Titel", 0L, -1, -1);
					break;
				case MENU_ENDE:
					oeffne_form(STAT_ENDE, texte[TXT_SE_TITEL].ob_spec.free_string, texte[TXT_SE_INFO].ob_spec.free_string, "ShutStat", 0L, -1, -1);
					break;
				case MENU_LAUF:
					oeffne_form(STAT_DAUER, texte[TXT_SD_TITEL].ob_spec.free_string, texte[TXT_SD_INFO].ob_spec.free_string, "LaufStat", 0L, -1, -1);
					break;
				case MENU_WTAG:
					oeffne_form(STAT_W, texte[TXT_SW_TITEL].ob_spec.free_string, texte[TXT_SW_INFO].ob_spec.free_string, "WochStat", 0L, -1, -1);
					break;
				case MENU_STUNDEN:
					oeffne_form(STAT_H, texte[TXT_SH_TITEL].ob_spec.free_string, texte[TXT_SH_INFO].ob_spec.free_string, "StdStat", 0L, -1, -1);
					break;
				case MENU_COLOR:
					balken[BALKEN_DEMO].ob_spec.obspec.interiorcol = fill_color[BS_SUMME];
					balken[BALKEN_DEMO].ob_spec.obspec.fillpattern = fill_style[BS_SUMME];
					balken[BALKEN_TEXT].ob_spec.tedinfo->te_color &= 0xF0FF;	/* Textcolor lschen	*/
					balken[BALKEN_TEXT].ob_spec.tedinfo->te_color |= text_color[BS_SUMME] << 8;
					itoa(min_breite, balken[BALKEN_BREITE].ob_spec.tedinfo->te_ptext, 10);
					oeffne_form(EINSTELLUNG, texte[TXT_EIN_TITEL].ob_spec.free_string, texte[TXT_EIN_INFO].ob_spec.free_string, "", bearbeite_einstellung, -1, -1);
					break;
				case MENU_MONAT:
					oeffne_form(STAT_M, texte[TXT_SM_TITEL].ob_spec.free_string, texte[TXT_SM_INFO].ob_spec.free_string, "MonStat", 0L, -1, -1);
					break;
				case MENU_BDAUER:
					if (bds == NULL) bds = create_fenster(texte[TXT_BD_TITEL].ob_spec.free_string, texte[TXT_BD_INFO].ob_spec.free_string , "BetrDau", NULL);
					if (bds != NULL) oeffne_fenster(bds, -1, -1, 200, 200);
					break;
				case MENU_FORT_TAGE:
					ft = oeffne_balken(texte[TXT_FT_TITEL].ob_spec.free_string, texte[TXT_FT_INFO].ob_spec.free_string, "fortTag", anz_ft, -1, -1, 500, 200);
					break;
				case MENU_FORT_WO:
					fw = oeffne_balken(texte[TXT_FW_TITEL].ob_spec.free_string, texte[TXT_FW_INFO].ob_spec.free_string, "fortWoch", anz_fw, -1, -1, 500, 200);
					break;
				case MENU_FORT_MON:
					fm = oeffne_balken(texte[TXT_FM_TITEL].ob_spec.free_string, texte[TXT_FM_INFO].ob_spec.free_string, "fortMon", anz_fm, -1, -1, 500, 200);
					break;
				case MENU_SAVE:
					speicher_log();
					break;
				case MENU_KONF:
					sichern_inf();
					break;
				case MENU_BETRIEB:
					log_win = oeffne_form(LOG_INFO, texte[TXT_LOG_TITEL].ob_spec.free_string, texte[TXT_LOG_INFO].ob_spec.free_string, "LogFile", 0L, -1, -1);
					log_win->topline = log_win->zeilen_anzahl - log_win->max_y;
					if (log_win->topline < 0) log_win->topline = 0;
					break;
				case MENU_ALL_CLOSE:
					close_all_windows();
					break;
				case MENU_WIN_CLOSE:
					schliesse_fenster(akt);
					break;
				case MENU_WIN_OPEN:
					close_all_windows();
					lese_inf();
					break;
				case MENU_WIN_DOWN:
					if (akt->next != NULL) wind_set( akt->next->wind_handle, WF_TOP);
					else wind_set( main_window->wind_handle, WF_TOP);
					break;
			}
			menu_tnormal( menu, buffer[3], TRUE );
			break;
		case AP_TERM:
				/* ******************************************** */
				/* Hier mu noch der Seicher aufgerumt werden!	*/
				/* ******************************************** */
			wind_update(END_UPDATE);
			return(TRUE);
		case WM_CLOSED:			/* Schliessbox	*/
			schliesse_fenster(akt);
			wind_update(END_UPDATE);
			break;
		case WM_FULLED:
			if (akt->fulled) {
				wind_get(akt->wind_handle, WF_PREVXYWH, &akt->fx, &akt->fy, &akt->fw, &akt->fh);
				akt->fulled = FALSE;
			} else {
				wind_get(akt->wind_handle, WF_FULLXYWH, &akt->fx, &akt->fy, &akt->fw, &akt->fh);
				akt->fulled = TRUE;
			}
			wind_set(akt->wind_handle, WF_CURRXYWH, akt->fx, akt->fy, akt->fw, akt->fh);
			wind_calc(WC_WORK, akt->art, akt->fx, akt->fy, akt->fw, akt->fh, &akt->ax, &akt->ay, &akt->aw, &akt->ah);
			if (akt->ob == NULL) {
				akt->max_x = akt->aw / min_breite;
			}
			break;
		case WM_MOVED:			/* Bewegen	*/
		case WM_SIZED:			/* Grsse ndern	*/
			akt->fx = buffer[4];
			akt->fy = buffer[5];
			akt->fw = buffer[6];
			akt->fh = buffer[7];
			wind_calc(WC_WORK, akt->art, buffer[4], buffer[5], buffer[6], buffer[7], &akt->ax, &akt->ay, &akt->aw, &akt->ah);
			wind_set(buffer[3], WF_CURRXYWH, akt->fx, akt->fy, akt->fw, akt->fh);
			if (akt->ob == NULL) {
				akt->max_x = akt->aw / min_breite;
				if (*buffer == WM_SIZED) {
					draw_inh(akt, NULL);
				}
			} else {
				akt->ob->ob_x = akt->ax;
				akt->ob->ob_y = akt->ay;
			}
			break;
		case WM_ARROWED:
			top = (int )akt->topline;
			left = akt->leftpos;
			switch(buffer[4]) {
				case WA_DNLINE:
					(akt->topline)++;
					break;
				case WA_UPLINE:
					(akt->topline)--;
					break;
				case WA_DNPAGE:
					akt->topline += (akt->max_y - 1);
					break;
				case WA_UPPAGE:
					akt->topline -= (akt->max_y - 1);
					break;
				case WA_RTLINE:
					(akt->leftpos)++;
					break;
				case WA_LFLINE:
					(akt->leftpos)--;
					break;
				case WA_RTPAGE:
					akt->leftpos += (akt->max_x - 1);
					break;
				case WA_LFPAGE:
					akt->leftpos -= (akt->max_x - 1);
					break;
			}
			if (akt->topline > akt->zeilen_anzahl - akt->max_y) akt->topline = akt->zeilen_anzahl - akt->max_y;
			if (akt->topline < 0) akt->topline = 0;
			if (akt->leftpos > akt->spalten_anzahl - akt->max_x) akt->leftpos = akt->spalten_anzahl - akt->max_x;
			if (akt->leftpos < 0) akt->leftpos = 0;
			if (akt->topline != top || akt->leftpos != left) draw_inh(akt, NULL);
			break;
		case WM_VSLID:
			akt->topline = (int )(((long )((akt->zeilen_anzahl - akt->max_y)) * buffer[4]) / 1000);
			draw_inh(akt, NULL);
			break;
		case WM_HSLID:
			akt->leftpos = (int )(((long )((akt->spalten_anzahl - akt->max_x)) * buffer[4]) / 1000);
			draw_inh(akt, NULL);
			break;
		case WM_REDRAW:			/* Neuzeichnen		*/
			clip.g_x = buffer[4];
			clip.g_y = buffer[5];
			clip.g_w = buffer[6];
			clip.g_h = buffer[7];
			draw_inh(akt, &clip);
			break;
		case WM_NEWTOP:
		case WM_ONTOP:
			break;
		case WM_TOPPED:			/* Nach oben holen	*/
			wind_set(buffer[3], WF_TOP);
			break;
		case WM_UNTOPPED:
			break;
		case WM_BOTTOM:
			wind_set(buffer[3], WF_BOTTOM);
			break;
	}
	wind_update(END_UPDATE);

	return(end);
}


/*-----------------------------------------------------------------------
!	Zeichnet den Inhalt eines Fensters
!	nur im Bereich clip. Sollte clip == NULL sein, so wird das ganze
!	sichtbare Fenster gezeichnet
+-----------------------------------------------------------------------*/

void draw_inh(FENSTER *akt, GRECT *clip)

{
	GRECT re;
	int pxyarray[4];

	if (akt == log_win) setze_log(log_info, (int )akt->topline);

	wind_get(akt->wind_handle, WF_FIRSTXYWH, &re.g_x, &re.g_y, &re.g_w, &re.g_h);
	while (re.g_w != 0 || re.g_h != 0) {
		if ((clip == NULL) || (intersect(&re, clip))) {
			graf_mouse(M_OFF, NULL);
			if (akt->ob == NULL) {
				pxyarray[0] = re.g_x;
				pxyarray[1] = re.g_y;
				pxyarray[2] = re.g_x + re.g_w - 1;
				pxyarray[3] = re.g_y + re.g_h - 1;
				if (color >= 4) vsf_color(vdi_handle, 8);
				else vsf_color(vdi_handle, 0);		/* Weier Hintergrund	*/
				vsf_style(vdi_handle, 8);
				vs_clip(vdi_handle, TRUE, pxyarray);
				v_bar(vdi_handle, pxyarray);
				
				if (akt == ft) draw_balken(akt, stat_ft, anz_ft);
				else if (akt == fw) draw_balken(akt, stat_fw, anz_fw);
				else if (akt == fm) draw_balken(akt, stat_fm, anz_fm);
				else if (akt == bds) draw_kreis(akt);
			}

			if (akt->art & VSLIDE) {
				if (akt->zeilen_anzahl > akt->max_y) wind_set(akt->wind_handle, WF_VSLIDE, (int )((akt->topline * 1000) / (akt->zeilen_anzahl - akt->max_y)));
				else wind_set(akt->wind_handle, WF_VSLIDE, 1000);
				if (akt->zeilen_anzahl > 0) wind_set(akt->wind_handle, WF_VSLSIZE, (int )(((long )akt->max_y * 1000) / akt->zeilen_anzahl));
				else wind_set(akt->wind_handle, WF_VSLSIZE, 1000);
			}
			if (akt->art & HSLIDE) {
				if (akt->spalten_anzahl - akt->max_x <= 0) wind_set(akt->wind_handle, WF_HSLIDE,1000);
				else wind_set(akt->wind_handle, WF_HSLIDE, (int )((akt->leftpos * 1000) / (akt->spalten_anzahl - akt->max_x)));
				if (akt->spalten_anzahl <= 0) wind_set(akt->wind_handle, WF_HSLSIZE, 1000);
				else wind_set(akt->wind_handle, WF_HSLSIZE, (int )(((long )akt->max_x * 1000) / akt->spalten_anzahl));
			}

			if (akt->ob != NULL) {
				objc_draw( akt->ob, 0, 10, re.g_x, re.g_y, re.g_w, re.g_h);
			}

			graf_mouse(M_ON, NULL);
		}
		wind_get(akt->wind_handle, WF_NEXTXYWH, &re.g_x, &re.g_y, &re.g_w, &re.g_h);
	}
}

/*------------------------------------------------------------------
!	Malt die Balkenstatistik nach den Vorgaben
+-----------------------------------------------------------------*/

void draw_balken(FENSTER *win, STATISTIK *werte, unsigned long anzahl)

{
	int breite, i, j, w, offset=10, tb,th, off_y=0;
	int pxyarray[12];
	char dummy[20];
	unsigned long max=0L;
	
	for (i = 0; i < anzahl; i++) max = MAX(werte[i].wert[BS_SUMME], max);

	breite = win->aw / anzahl;

	if (breite < min_breite) {
		offset = 0;
		breite = min_breite;
	} else {
		offset = (win->aw - (breite * anzahl)) / 2;
	}
	if (win->leftpos + win->max_x > win->spalten_anzahl) win->leftpos = win->spalten_anzahl - win->max_x;
	if (win->leftpos < 0) win->leftpos = 0;
	
	for (i = 0, w = win->leftpos; i <= win->max_x && w < anzahl; i++, w++) {
		off_y = win->ay + win->ah-5;
		for (j = BS_SUMME+1; j <= BS_UNBEK; j++) {
			if (werte[w].wert[j] <= 0) continue;

			vsf_interior(vdi_handle, FIS_PATTERN);
			if (fill_style[j] >=7 ) vsf_style(vdi_handle, 8);
			else vsf_style(vdi_handle, fill_style[j]);
			if (fill_style[j] <= 0) vsf_interior(vdi_handle, FIS_HOLLOW);

			vsl_color(vdi_handle, fill_color[j]);
			vsf_color(vdi_handle, fill_color[j]);
			pxyarray[0] = win->ax + offset + (breite * i);
			pxyarray[2] = pxyarray[0] + breite - 1;
			pxyarray[3] = off_y;
			pxyarray[1] = pxyarray[3] - (werte[w].wert[j] * (win->ah-20) / max);
			vswr_mode(vdi_handle, MD_REPLACE);
			if (fill_style[j] > 0 || fill_color[j] > 0) v_bar(vdi_handle, pxyarray);
			if (color >= 4 && breite > 1) {	/* 3D mglich und sinnvoll	*/
				vsl_color(vdi_handle, 0);
				pxyarray[4] = pxyarray[2];
				pxyarray[5] = pxyarray[1];
				pxyarray[6] = pxyarray[0];
				pxyarray[7] = pxyarray[1];
				pxyarray[8] = pxyarray[0];
				pxyarray[9] = pxyarray[3];
				v_pline(vdi_handle, 3, &pxyarray[4]);
				if (fill_color[j] > 0) vsl_color(vdi_handle, fill_color[j]+8);
				else vsl_color(vdi_handle, 1);
				pxyarray[6] = pxyarray[2];
				pxyarray[7] = pxyarray[3];
				v_pline(vdi_handle, 3, &pxyarray[4]);
			}
			if (werte[w].wert[j] > 0) off_y=pxyarray[1]-1;
		}
		vswr_mode(vdi_handle, MD_TRANS);
		vst_rotation(vdi_handle, 0);
		vst_color(vdi_handle, 1);
		vst_height(vdi_handle, 4, &j,&j,&j,&j);
		ltoa(werte[w].wert[BS_SUMME]/60L, dummy, 10);
		vqt_extent(vdi_handle, dummy, &pxyarray[4]);
		tb = pxyarray[6]-pxyarray[4];
		th = pxyarray[11]-pxyarray[5];
		v_gtext(vdi_handle, pxyarray[0]+((breite-tb)/2), pxyarray[1]-3, dummy);

		vst_rotation(vdi_handle, 900);
		vst_height(vdi_handle, 14, &j,&j,&j,&j);
		vst_color(vdi_handle, text_color[BS_SUMME]);
		vqt_extent(vdi_handle, werte[w].text, &pxyarray[4]);
		tb = pxyarray[4]-pxyarray[10];
		th = pxyarray[7]-pxyarray[5];
		if (tb < pxyarray[2]-pxyarray[0] && th+3 < pxyarray[3]-pxyarray[1]) 
			v_gtext(vdi_handle, pxyarray[0]+tb, pxyarray[3]-2, werte[w].text);
	}
}

/*------------------------------------------------------------------
!	Zeichnet den Betriebsdauerkreis
+-----------------------------------------------------------------*/

void draw_kreis(FENSTER *akt)

{
	int wert, rad, x, y, end, start, i;
	char proz[10];
	float p;
	int pxyarray[8];
	
	rad = (MIN(akt->aw, akt->ah) / 2) - 5;
	p = ((float )bs_stat[BS_SUMME].betriebssekunden / (float)messzeit);
	wert = (int )(p * (float )1800);
	if ((start = 900 - wert) < 0) start += 3600;
	if ((end = 900 + wert) > 3600) end -= 3600;
	x = (akt->aw / 2) + akt->ax;
	y = (akt->ah / 2) + akt->ay;
	
	itoa((int )(p * (float )10000), proz, 10);
	
	if ((i = strlen(proz)) >= 3) {
		proz[i+1] = proz[i];
		proz[i] = proz[i-1];
		proz[i-1] = proz[i-2];
		proz[i-2] = ',';
	} else if (i == 2) {
		proz[4] = '\0';
		proz[3] = proz[1];
		proz[2] = proz[0];
		proz[1] = ',';
		proz[0] = '0';
	} else {
		proz[4] = '\0';
		proz[3] = proz[0];
		proz[2] = '0';
		proz[1] = ',';
		proz[0] = '0';
	}
	strcat(proz, "%");
	vqt_extent(vdi_handle, proz, pxyarray);
	
	if (color >= 4) {	/* ab 6 Farben!	*/
		vsl_color(vdi_handle, 0);
		v_arc(vdi_handle, x-1, y-1, rad, 0, 3600);
	}
	vsl_color(vdi_handle, fill_color[BS_SUMME]);
	v_arc(vdi_handle, x, y, rad, 0, 3600);
	if (color >= 4) {
		if (fill_color > 0) vsl_color(vdi_handle, fill_color[BS_SUMME]+8);
		else vsl_color(vdi_handle, 1);
		v_arc(vdi_handle, x+1, y+1, rad, 0, 3600);
	}

	vsf_color(vdi_handle, fill_color[BS_SUMME]);
	vsf_interior(vdi_handle, FIS_PATTERN);
	if (fill_style[BS_SUMME] >=7 ) vsf_style(vdi_handle, 8);
	else vsf_style(vdi_handle, fill_style[BS_SUMME]);
	if (fill_style[BS_SUMME] <= 0) vsf_interior(vdi_handle, FIS_HOLLOW);
	v_pieslice(vdi_handle, x, y, rad, start, end);
	
	vst_rotation(vdi_handle, 0);
	vst_color(vdi_handle, text_color[BS_SUMME]);
	vst_height(vdi_handle, 4, &i,&i,&i,&i);
	v_gtext(vdi_handle, x-((pxyarray[2]-pxyarray[0])/2), (y-rad)+(pxyarray[7]-pxyarray[1])+5, proz);

}

/*----------------------------------------------------------------
!	Behandelt die Nachrichten 
+-----------------------------------------------------------------*/

int message_button(int mx, int my, int mb, int ks)

{
	int next_ob, exit, erg, x_window;
	FENSTER *akt;

	x_window = wind_find(mx, my);
	for (akt = main_window; akt != NULL && akt->wind_handle != x_window; akt = akt->next);
	
	if (akt == NULL) return(FALSE);		/* Kein entsprechendes Fenster gefunden	*/
	
	if (akt->ob != NULL) {				/* Objekt bedienung	*/
		erg = objc_find(akt->ob, 0, 10, mx, my);
		if ((erg < 0) || (akt->ob[erg].ob_state & DISABLED) ) {
			wind_set(akt->wind_handle, WF_TOP);	/* Kein Button, dann toppen	*/
			return(FALSE);
		}
	
		exit = form_button(akt->ob, erg, 1, &next_ob);
		if (exit == 0) {	/* Exitbutton gedrckt	*/
			akt->exit_ob(erg, akt);	/* definierte Funktion aufrufen	*/
		}
	}

	return(FALSE);
}

/*----------------------------------------------------------------
!	Berechnet aus zwei Rechtecken das Rechteck, das gezeichnet
!	werden soll
+-----------------------------------------------------------------*/

int	intersect(GRECT *re_1, GRECT *re_2)

{
	GRECT erg;

	if (re_1->g_x + re_1->g_w <= re_2->g_x) return(FALSE);
	if (re_2->g_x + re_2->g_w <= re_1->g_x) return(FALSE);
	if (re_1->g_y + re_1->g_h <= re_2->g_y) return(FALSE);
	if (re_2->g_y + re_2->g_h <= re_1->g_y) return(FALSE);
	erg.g_x = MAX(re_1->g_x, re_2->g_x);
	erg.g_y = MAX(re_1->g_y, re_2->g_y);
	erg.g_w = MIN(re_1->g_x + re_1->g_w, re_2->g_x + re_2->g_w) - erg.g_x;
	erg.g_h = MIN(re_1->g_y + re_1->g_h, re_2->g_y + re_2->g_h) - erg.g_y;
	re_1->g_x = erg.g_x;
	re_1->g_y = erg.g_y;
	re_1->g_w = erg.g_w;
	re_1->g_h = erg.g_h;

	return(TRUE);
}

/*-------------------------------------------------------------------------
!	Erzeugt ein Fenster, initialisiert dieses und hngt die FENSTER-Struktu
!	in die doppeltverkettete Liste ein.
+--------------------------------------------------------------------------
!	Eingabe:
!		char	*name	Gibt den Fenstertitel an
!		char	*info	Gibt die Infozeile an 
!		char	*inf	Gibt die Kennung fr die INF-Datei an
!		OBJECT	*ob		Gibt ein anzuzeigendes Object an
!	Ausgabe:
!		FENSTER *		Gibt die Adresse des neuen Fensters zurck
+-------------------------------------------------------------------------*/

FENSTER *create_fenster(char *name, char *info, char *inf, OBJECT *ob)

{
	FENSTER *win, *w;
	int i, fx,fy,fw,fh;
	
	win = (FENSTER *) malloc( sizeof(FENSTER));
	if (win == NULL) return(NULL);

	memset(win, 0, sizeof(FENSTER));
	win->init = win->aktiv = FALSE;			/* Es darf noch keiner zugreifen!	*/
	win->next = win->before = NULL;
	win->ob = ob;
	win->info[0] = 	win->name[0] = win->inf[0] = '\0';

	win->art = NAME|CLOSER|MOVER;
	
	if (ob == NULL) {
		win->art |= FULLER|SIZER;
		if (strcmp(inf, "BetrDau") != 0) win->art |= LFARROW|RTARROW|HSLIDE;
	} else if (ob == log_info) {
		win->art |= UPARROW|DNARROW|VSLIDE;
	}
	
	if (info != NULL && *info != '\0') {
		win->art |= INFO;
		strncat(win->info, info, 80);
	}
	strncat(win->name, name, 80);
	strcpy(win->inf, inf);
	
	wind_get(0, WF_WORKXYWH, &fx, &fy, &fw, &fh);	/* Maximalgre holen	*/
	if (ob == NULL) {			/* Kein Formular, dann grte Breite errechnen!	*/
		win->fx = fx;
		win->fy = fy;
		win->fw = fw;
		win->fh = fh;
		wind_calc(WC_WORK, win->art, win->fx, win->fy, win->fw, win->fh, 
									&win->ax, &win->ay, &win->aw, &win->ah);
	} else {					/* Gre anhand des Formulars errechnen	*/
		if (ob->ob_x != 0 || ob->ob_y != 0) {
			win->ax = ob->ob_x;
			win->ay = ob->ob_y;
			win->aw = ob->ob_width;
			win->ah = ob->ob_height;
		} else form_center(ob, &win->ax, &win->ay, &win->aw, &win->ah);
		wind_calc(WC_BORDER, win->art, win->ax, win->ay, win->aw, win->ah, 
									  &win->fx, &win->fy, &win->fw, &win->fh);
		if (win->fx < fx) {		/* Anpaen, da das Fenster nicht auerhalb des Fensters liegt!	*/
			i = win->ax - win->fx;
			win->fx = fx;
			win->ob->ob_x = win->ax = i + win->fx;
		}
		if (win->fy < fy) {
			i = win->ay - win->fy;
			win->fy = fy;
			win->ob->ob_y = win->ay = i + win->fy;
		}
	}
	win->wind_handle = wind_create(win->art, win->fx, win->fy, win->fw, win->fh);
	win->max_x = win->aw / min_breite;
	
	if (win->wind_handle < 0) {		/* Kein Window-handle mehr!	*/
		form_alert(1,texte[TXT_NO_WINDOW].ob_spec.free_string);
		free(win);
		return(NULL);
	}
	
	if (win->wind_handle > 0) {
		if (win->art & MOVER) wind_set(win->wind_handle, WF_NAME, win->name, 0, 0);
		if (win->art & INFO) wind_set(win->wind_handle, WF_INFO, win->info, 0, 0);
		if (win->art & HSLIDE){
			wind_set(win->wind_handle, WF_HSLSIZE, 1000);
			wind_set(win->wind_handle, WF_HSLIDE, 0);
		}
		if (win->art & VSLIDE) {
			wind_set(win->wind_handle, WF_VSLSIZE, 1000);
			wind_set(win->wind_handle, WF_VSLIDE, 0);
		}
	}
	
	win->init=TRUE;
	win->fulled = FALSE;
	
	if (main_window != NULL) {
		for (w = main_window; w->next != NULL; w = w->next);	/* Ende der Liste suchen	*/
		win->before = w;
		w->next = win;
	} else {
		main_window = win;
	}

	return(win);
}

/*------------------------------------------------------------------------------
!	ffnet ein Fenster in der angegebenen Gre
!	und an der angegebenen Position
!	Das Fenster mu vorher mit create_fenster erzeugt worden sein!
+-------------------------------------------------------------------------------
!	Eingabe:
!		FENSTER *win	Zeiger auf die Fensterstruktur, das geffnet werden soll
!		int		x		X-Koordinate des zu ffnenden Fensters (-1=zentriert)
!		int		y		Y-Koordinate des zu ffnenden Fensters (-1=zentriert)
!		int		w		Breite des zu ffnenden Fensters (-1=maximalbreite)
!		int		h		Hhe des zu ffnenden Fensters	 (-1=maximalhhe)
!	Ausgabe:
!		-
+-----------------------------------------------------------------------------*/

void oeffne_fenster(FENSTER *win, int x, int y, int w, int h)

{
	int mx,my,mw,mh;
	
	if (win == NULL) return;

	wind_get(0, WF_WORKXYWH, &mx, &my, &mw, &mh);	/* Maximalgre holen	*/

	if (!win->aktiv) {			/* noch nicht geffnet	*/
		if (w < 0) w = win->fw;
		if (h < 0) h = win->fh;
		if (x < 0) win->fx = (mw - w) / 2;
		else win->fx = x;
		if (y < 0) win->fy = (mh - h) / 2;
		else win->fy = y;
		if (win->ob == NULL) {	/* kein Dialog	*/
			if (win->fx + w > mw) win->fw = mw - x;
			else win->fw = w;
			if (win->fy + h > mh) win->fh = mh - y;
			else win->fh = h;
		}

		wind_calc(WC_WORK, win->art, win->fx, win->fy, win->fw, win->fh, 
									&win->ax, &win->ay, &win->aw, &win->ah);
		wind_open( win->wind_handle, win->fx, win->fy, win->fw, win->fh );
		win->aktiv = TRUE;
	} else {
		wind_set(win->wind_handle, WF_TOP);
	}
	return;
}

/*----------------------------------------------------------------------
!	Setzt die bergebene Zeile im Objekt
!	Es wird kein CHECK & SET verwendet, da keine Zeitkritischen
!	Verfahren implementiert sind!
+------------------------------------------------------------------------
!	Eingabe:
!		FENSTER *win	Zeiger auf die Fensterstruktur, in der der Inhalt abgelegt wird
!		int		kind	das x. Objekt im Baum soll gezeichnet werden
!		char	*text	Der Text soll im Objekt voher gesetzt werden
!	Ausgabe:
!		-
+-------------------------------------------------------------------------*/

void setze_ob(FENSTER *win, int kind, char *text)

{
	TEDINFO *te;
	int type;
	int x,y,w,h;
	int tiefe = 0; 
	
	type = win->ob[kind].ob_type;
	
	if ((text != NULL && (
		(type == G_TEXT) || 
		(type == G_BOXTEXT) ||
		(type == G_FTEXT) || 
		(type == G_FBOXTEXT)))) {
		te = win->ob[kind].ob_spec.tedinfo;
		*te->te_ptext = '\0';
		strncat(te->te_ptext, text, te->te_txtlen - 1);
	} else if ((text != NULL) && (type == G_STRING)) {
		strcpy(win->ob[kind].ob_spec.free_string, text);
	} else tiefe = 10;
	
	if (!win->aktiv) return;
	wind_update(BEG_UPDATE);
	wind_get(win->wind_handle, WF_FIRSTXYWH, &x, &y, &w, &h);
	while (w != 0 || h != 0) {
		objc_draw(win->ob, kind, tiefe, x, y, w, h);
		wind_get(win->wind_handle, WF_NEXTXYWH, &x, &y, &w, &h);
	} 
	wind_update(END_UPDATE);
}


/*-------------------------------------------------------------------------
!	Lscht die interne Struktur und gibt allen Speicher frei!
!	Setzt auerdem die Verkettung der anderen Fenster wieder korrekt!
+--------------------------------------------------------------------------
!	Eingabe:
!		FENSTER *win		Zeiger auf die Fensterstruktur
!	Ausgabe:
!		keine
+-------------------------------------------------------------------------*/

void schliesse_fenster(FENSTER *win)

{
	wind_close(win->wind_handle);
	wind_delete(win->wind_handle);
	win->aktiv = FALSE;
	
	if (win->before != NULL) win->before->next = win->next;
	else main_window = win->next;

	if (win->next != NULL) win->next->before = win->before;
	if (ft == win) ft = NULL;
	if (fw == win) fw = NULL;
	if (fm == win) fm = NULL;
	if (bds == win) bds = NULL;
	if (log_win == win) log_win = NULL;
	
	free(win);
}

/*-------------------------------------------------------------------------
!	ffnet ein Formular in einem Fenster, initialisiert dieses und hngt
!	die FENSTER-Struktur in die doppeltverkettete Liste ein.
!	Ist das Objekt bereits geffnet, wird nur das Fenster getopped
+--------------------------------------------------------------------------
!	Eingabe:
!		int		index		Gibt den index des zu zeichnenden Objects an
!		char	*titel		Gibt den Namen des Fensters an!
!		char	*infoline	Gibt die infozeile des Fensters an!
!		char	*inf		Gibt den Infotext in er SEEBAER.INF an
!		void (*exit_ob)( )	Zeiger auf eine Prozedur, die das Formular bearbeitet
!	Ausgabe:
!		FENSTER *			Gibt die Adresse des neuen Fensters zurck
+-------------------------------------------------------------------------*/

FENSTER *oeffne_form(int index, char *titel, char *infoline, char *inf, void (*exit_ob) (int exit, FENSTER *win  ), int px, int py)

{
	OBJECT *ob;
	FENSTER *win;
	
	rsrc_gaddr(0, index, &ob);
	
	for (win = main_window; win != NULL && win->ob != ob; win = win->next);
	
	if (win == NULL) {
		win = create_fenster(titel, infoline, inf, ob);
		if (win != NULL) {
			win->exit_ob = exit_ob;
			if (px >= 0) win->fx = px;
			if (py >= 0) win->fy = py;
			if (px >= 0  || py >= 0) {
				wind_calc(WC_WORK, win->art, win->fx, win->fy, win->fw, win->fh, 
								&win->ax, &win->ay, &win->aw, &win->ah);
				win->ob->ob_x = win->ax;
				win->ob->ob_y = win->ay;
			}
			wind_open( win->wind_handle, win->fx, win->fy, win->fw, win->fh );
			win->aktiv = TRUE;
		}
	} else {
		wind_set(win->wind_handle, WF_TOP);
	}
	return(win);
}

/*-----------------------------------------------------------------------------
!	Bearbeitet das Formular einstellungen
+---------------------------------------------------------------------------*/

void bearbeite_einstellung (int exit, FENSTER *win  )

{
	FENSTER *w;
	int s,a,i;
	char br[4];
	
	if (exit >= BALKEN_FARBE && exit <= BALKEN_FARBE + 15) {
		win->ob[BALKEN_DEMO].ob_spec.obspec.interiorcol = win->ob[exit].ob_spec.obspec.interiorcol;
		setze_ob(win, BALKEN_DEMO, NULL);
	} else if (exit >= BALKEN_MUSTER && exit <= BALKEN_MUSTER + 7) {
		win->ob[BALKEN_DEMO].ob_spec.obspec.fillpattern = win->ob[exit].ob_spec.obspec.fillpattern;
		setze_ob(win, BALKEN_DEMO, NULL);
	} else if (exit >= TEXT_FARBE && exit <= TEXT_FARBE + 15) {
		win->ob[BALKEN_TEXT].ob_spec.tedinfo->te_color &= 0xF0FF;	/* Textcolor lschen	*/
		win->ob[BALKEN_TEXT].ob_spec.tedinfo->te_color |= win->ob[exit].ob_spec.obspec.interiorcol << 8;
		setze_ob(win, BALKEN_TEXT, NULL);
	} else if (exit == BB_KLEINER) {
		i = atoi(win->ob[BALKEN_BREITE].ob_spec.tedinfo->te_ptext) - 1;
		if (i < 1) i = 1;
		itoa(i, br, 10);
		setze_ob(win, BALKEN_BREITE, br);
	} else if (exit == BB_GROESSER) {
		i = atoi(win->ob[BALKEN_BREITE].ob_spec.tedinfo->te_ptext) + 1;
		if (i > 999) i = 999;
		itoa(i, br, 10);
		setze_ob(win, BALKEN_BREITE, br);
	}
	win->ob[exit].ob_state &= ~SELECTED;
	setze_ob(win, exit, NULL);
	
	if (exit == EINST_SETZEN || exit == EINST_OK) {
		min_breite = atoi(win->ob[BALKEN_BREITE].ob_spec.tedinfo->te_ptext);
		fill_style[BS_SUMME] = win->ob[BALKEN_DEMO].ob_spec.obspec.fillpattern;
		fill_color[BS_SUMME] = win->ob[BALKEN_DEMO].ob_spec.obspec.interiorcol;
		text_color[BS_SUMME] = (win->ob[BALKEN_TEXT].ob_spec.tedinfo->te_color & 0x0F00) >> 8;
		w = main_window;
		while (w != NULL) {
			if (w->ob != NULL) {
				s=a=-1;
				if (w->ob == ob_stat_h) { s=NULL_UHR; a=23; }
				else if (w->ob == ob_stat_w) { s=MONTAG; a=6; }
				else if (w->ob == ob_stat_m) { s=JANUAR; a=11; }
				else if (w->ob == ob_stat_e) { s=ABSTURZ; a=2; }
				else if (w->ob == ob_stat_d) { s=UNTER1MIN; a=11; }
				if (a >= 0) {
					for ( ; a >= 0; a--) {
						w->ob[s+a].ob_spec.obspec.fillpattern = fill_style[BS_SUMME];
						w->ob[s+a].ob_spec.obspec.interiorcol = fill_color[BS_SUMME];
					}
				}
			} else {
				w->max_x = w->aw / min_breite;
			}
			draw_inh(w, NULL);	/* ganzes Fenster zeichnen	*/
			w = w->next;
		}
	}
	if (exit == EINST_OK || exit == EINST_ABBRUCH) schliesse_fenster(win);
}

/*--------------------------------------------------------------------------------
!	Ldt die Protokolldatei ein und fllt das Formular
+------------------------------------------------------------------------------*/

void lade_proto(void)

{
	int fd, i, mo, ja, wo, bs;
	long l, a;
	unsigned long sek;
	XATTR xattr;
	DTA *dta;
	DOSDATE dt;
	struct tm tm, *te;
	time_t time;
	
	l = Fxattr(0, proto_file, &xattr);
	if (l == -32) {			/* Funktion nicht verfgbar!	*/
		i = Fsfirst(proto_file, 0);
		if (i == 0) {		/* Datei Gefunden!	*/
			dta = Fgetdta();
			xattr.size = dta->d_length;
			l = 0;			/* Datei gefunden	*/
		} else l = -33;		/* File not found	*/
	}
	if (l < 0) {
		form_alert(1,texte[TXT_NO_LOGFILE].ob_spec.free_string);
		max_log = 0;
		return;
	}
	if (xattr.size < 0) return;
	log = (LOG *)Malloc(xattr.size);
	if (log == NULL) return;
	
	l = Fopen(proto_file, FO_READ);	/* Daten lesen!	*/
	if (l > 0) {					/* Wenn Fehler, dann nichts machen!	*/
		fd = (int )l;
		l = Fread(fd, xattr.size, log);
		max_log = l / sizeof(LOG);
		Fclose(fd);
		dt.dost.time = Tgettime();		/* Messzeit feststellen	*/
		dt.dost.date = Tgetdate();
/* Maximale Werte ermitteln!	*/
		messzeit = diff_time(&log[0].dt, &dt.dati, &i, &i);
		setze_hstat(BS_UNBEK, messzeit, &log[0].dt);
		setze_wstat(BS_UNBEK, messzeit, &log[0].dt);
		setze_mstat(BS_UNBEK, messzeit, &log[0].dt);
		for (i = 0; i < 24; i++) { 
			stat_h_max[i] = bs_stat[BS_SUMME].stat_h[i]; 
			bs_stat[BS_SUMME].stat_h[i] = bs_stat[BS_UNBEK].stat_h[i] = 0; 
		}
		for (i = 0; i < 7; i++)  { 
			stat_w_max[i] = bs_stat[BS_SUMME].stat_w[i]; 
			bs_stat[BS_SUMME].stat_w[i] = bs_stat[BS_UNBEK].stat_w[i] = 0; 
		}
		for (i = 0; i < 12; i++) { 
			stat_m_max[i] = bs_stat[BS_SUMME].stat_m[i]; 
			bs_stat[BS_SUMME].stat_m[i] = bs_stat[BS_UNBEK].stat_m[i] = 0;
		}

		tm.tm_mday = log[0].dt.day;
		tm.tm_mon = log[0].dt.month-1;
		tm.tm_year = log[0].dt.year+80;
		tm.tm_hour = tm.tm_min = tm.tm_sec = tm.tm_wday = 0;

		anz_ft = (get_tage(&dt.dati) - get_tage(&log[0].dt)) + 1;
		stat_ft = malloc(sizeof(STATISTIK) * anz_ft);
		if (stat_ft != NULL) {
			memset(stat_ft, 0, sizeof(STATISTIK) * anz_ft);
			time = mktime(&tm);
			for (i = 0; i < anz_ft; i++) {
				te = localtime(&time);
				intoa(te->tm_mday, stat_ft[i].text, 2);
				intoa(te->tm_mon+1, &stat_ft[i].text[3], 2);
				if (te->tm_year > 100) intoa(te->tm_year-100, &stat_ft[i].text[6], 2);
				else intoa(te->tm_year, &stat_ft[i].text[6], 2);
				stat_ft[i].text[2] = stat_ft[i].text[5] = '.';
				time += 86400L;
			}
		}

		time = mktime(&tm);
		te = localtime(&time);
		wo = te->tm_wday - 1;
		if (wo < 0) wo = 6;
		time -= wo * 86400L;
		anz_fw = ((anz_ft + wo - 1)/7)+1;
		stat_fw = malloc(sizeof(STATISTIK) * anz_fw);
		if (stat_fw != NULL) {
			memset(stat_fw, 0, sizeof(STATISTIK) * anz_fw);
			for (i = 0; i < anz_fw; i++) {
				te = localtime(&time);
				intoa(te->tm_mday, stat_fw[i].text, 2);
				intoa(te->tm_mon+1, &stat_fw[i].text[3], 2);
				if (te->tm_year > 100) intoa(te->tm_year-100, &stat_fw[i].text[6], 2);
				else intoa(te->tm_year, &stat_fw[i].text[6], 2);
				stat_fw[i].text[2] = stat_fw[i].text[5] = '.';
				time += 604800L;
			}
		}

		anz_fm = ((dt.dati.month - log[0].dt.month) + ((dt.dati.year - log[0].dt.year)*12) + 1);
		stat_fm = malloc(sizeof(STATISTIK) * anz_fm);
		if (stat_fm != NULL) {
			memset(stat_fm, 0, sizeof(STATISTIK) * anz_fm);
			mo = log[0].dt.month-1;
			ja = log[0].dt.year+80;
			for (i = 0; i < anz_fm; i++) {
				strcpy(stat_fm[i].text, mon[mo]);
				strcat(stat_fm[i].text, " ");
				if (ja >= 100) ja -= 100;
				intoa(ja, &stat_fm[i].text[4], 2);
				if (++mo >= 12) {
					ja++;
					mo = 0;
				}
			}
		}
		
	}


	for (i = BS_SUMME; i <= BS_UNBEK; bs_stat[i++].betriebssekunden = 0L);
	
	for (a = l = 0; l < max_log; l++) {
		if (log[l].status == 'S') {
			a = l;
			eintraege++;
		} else {
			if (log[a].status == 'S') {
				switch(log[l].bs) {
					case 'S':	bs=BS_STOS; break;
					case 'M':	bs=BS_MINT; break;
					case 'N':	bs=BS_NAES; break;
					case 'C':	bs=BS_MAGX; break;
					default:	bs=BS_UNBEK; break;
				}
				switch(log[l].status) {
					case 'A':	bs_stat[bs].stat_e[0]++; bs_stat[BS_SUMME].stat_e[0]++; break;
					case 'R':	bs_stat[bs].stat_e[1]++; bs_stat[BS_SUMME].stat_e[1]++; break;
					case 'E':	bs_stat[bs].stat_e[2]++; bs_stat[BS_SUMME].stat_e[2]++; break;
				}
				sek = diff_time(&log[a].dt, &log[l].dt, &i, &i);
				bs_stat[bs].betriebssekunden += sek;
				bs_stat[BS_SUMME].betriebssekunden += sek;

				setze_hstat(bs, sek, &log[a].dt);
				setze_wstat(bs, sek, &log[a].dt);
				setze_mstat(bs, sek, &log[a].dt);

				if (sek < 60) i=0;
				else if (sek < 5*60L) i=1;
				else if (sek < 15*60L) i=2;
				else if (sek < 30*60L) i=3;
				else if (sek < 60*60L) i=4;
				else if (sek < 2*3600L) i=5;
				else if (sek < 4*3600L) i=6;
				else if (sek < 8*3600L) i=7;
				else if (sek < 12*3600L) i=8;
				else if (sek < 18*3600L) i=9;
				else if (sek < 24*3600L) i=10;
				else i=11;
				
				bs_stat[bs].stat_d[i]++;
				bs_stat[BS_SUMME].stat_d[i]++;
				a = l;
			}
		}
	}

	if (log[max_log-1].status == 'S') {	/* Aktuelle Betriebsdauer dazuzhlen!	*/

		sek = diff_time(&log[max_log-1].dt, &dt.dati, &i, &i);
		bs_stat[bs].betriebssekunden += sek;
		bs_stat[BS_SUMME].betriebssekunden += sek;

		setze_hstat(bs, sek, &log[max_log-1].dt);
		setze_wstat(bs, sek, &log[max_log-1].dt);
		setze_mstat(bs, sek, &log[max_log-1].dt);

		if (sek < 60) i=0;
		else if (sek < 5*60L) i=1;
		else if (sek < 15*60L) i=2;
		else if (sek < 30*60L) i=3;
		else if (sek < 60*60L) i=4;
		else if (sek < 2*3600L) i=5;
		else if (sek < 4*3600L) i=6;
		else if (sek < 8*3600L) i=7;
		else if (sek < 12*3600L) i=8;
		else if (sek < 18*3600L) i=9;
		else if (sek < 24*3600L) i=10;
		else i=11;
				
		bs_stat[bs].stat_d[i]++;
		bs_stat[BS_SUMME].stat_d[i]++;

	}

}

/*------------------------------------------------------------------------
!	Setzt die Variablen fr die Stundenstatistik
+-----------------------------------------------------------------------*/

void setze_hstat(int bs, unsigned long sekunden, DATETIME *start_zeit)

{
	int stunde;
	unsigned long zeit, diff;
	
	stunde = start_zeit->hour;			/* Startstunde berechnen	*/
	zeit = 3600 - ((long )(start_zeit->second * 2) + (long )(start_zeit->minute * 60));	/* sekunden der ersten Stunde berechnen	*/
	do {
		diff = (zeit < sekunden) ? zeit : sekunden;
		bs_stat[bs].stat_h[stunde] += diff;
		bs_stat[BS_SUMME].stat_h[stunde] += diff;
		sekunden -= diff;

		if (++stunde >= 24) stunde = 0;
		zeit = 3600;
	} while (sekunden > 0);
}

/*------------------------------------------------------------------------
!	Setzt die Variablen fr die Wochentagsstatistik, die fortlaufende Tagesstatistik
!	und die fortlaufende Wochenstatistik
+-----------------------------------------------------------------------*/

void setze_wstat(int bs, unsigned long sekunden, DATETIME *start_zeit)

{
	int wtag;
	unsigned long zeit, diff, tag, woche;
	
	wtag = get_tage(start_zeit) % 7;		/* 1.1.80 war ein Dienstag, daher pat es schn	*/
	tag = get_tage(start_zeit) - get_tage(&log[0].dt);
	woche = ((tag - wtag)+6)/7;

	zeit = 86400L - ((long )(start_zeit->second * 2) + (long )(start_zeit->minute * 60) + (long )(start_zeit->hour * 3600));
	
	do {
		diff = (zeit < sekunden) ? zeit : sekunden;
		bs_stat[bs].stat_w[wtag] += diff;
		bs_stat[BS_SUMME].stat_w[wtag] += diff;
		if (stat_ft != NULL) {
			stat_ft[tag].wert[bs] += diff;
			stat_ft[tag].wert[BS_SUMME] += diff;
		}
		if (stat_fw != NULL) {
			stat_fw[woche].wert[bs] += diff;
			stat_fw[woche].wert[BS_SUMME] += diff;
		}
		sekunden -= diff;
		
		tag++;
		if (++wtag >= 7) {
			wtag = 0;
			woche++;
		}
		zeit = 86400L;
	} while (sekunden > 0);
}

/*------------------------------------------------------------------------
!	Setzt die Variablen fr die Monatstatistiken (alle beide!)
+-----------------------------------------------------------------------*/

void setze_mstat(int bs, unsigned long sekunden, DATETIME *start_zeit)

{
	int monat;
	time_t zeit, diff;
	long l;

	struct tm tm_s, tm_e;
	time_t sec_s, sec_e;
	
	tm_s.tm_sec = start_zeit->second * 2;
	tm_s.tm_min = start_zeit->minute;
	tm_s.tm_hour = start_zeit->hour;
	tm_s.tm_mday = start_zeit->day;
	tm_s.tm_mon = start_zeit->month - 1;	/* Monate von 0-11!	*/
	tm_s.tm_year = start_zeit->year + 80;/* Basis is 1900 anstatt 1980!	*/
	
	sec_s = mktime(&tm_s);

	tm_e.tm_sec = tm_e.tm_min = tm_e.tm_hour = 0;
	tm_e.tm_mday = 1;
	tm_e.tm_mon = start_zeit->month;	/* Monate von 0-11!	aber einen weiter als Startzeit! */
	tm_e.tm_year = start_zeit->year + 80;/* Basis is 1900 anstatt 1980!	*/
	if (tm_e.tm_mon >= 12) {
		tm_e.tm_mon = 0;
		tm_e.tm_year++;
	}
	sec_e = mktime(&tm_e);
	
	monat = start_zeit->month-1;			/* Startmonat berechnen	*/
	zeit = sec_e - sec_s;	/* sekunden des ersten Monats berechnen	*/
	do {
		diff = (zeit < sekunden) ? zeit : sekunden;
		bs_stat[bs].stat_m[monat] += diff;
		bs_stat[BS_SUMME].stat_m[monat] += diff;
		sekunden -= diff;
		
		if (stat_fm != NULL) {
			l = (tm_e.tm_mon - log[0].dt.month) + ((tm_e.tm_year - 80 - log[0].dt.year)*12);
			stat_fm[l].wert[bs] += diff;
			stat_fm[l].wert[BS_SUMME] += diff;
		}

		if (++monat >= 12) monat = 0;
		if (++tm_e.tm_mon >= 12) {			/* nchster Monat	*/
			tm_e.tm_mon = 0;
			tm_e.tm_year++;
		}
		sec_s = sec_e;
		sec_e = mktime(&tm_e);
		zeit = sec_e - sec_s;
	} while (sekunden > 0);
}


/*------------------------------------------------------------------------
!	Setzt die Statistik
!	int text gibt die Objectnr. eines zugehrigen Textes an!
!	d1 gibt die Anzahl der whrend der Betriebszeit getouchten Balken an
!	d2 gibt an, in welcher einheit der Blken angegeben ist (60=min, 3600=h)
+----------------------------------------------------------------------*/

void setze_stat(OBJECT *ob, int kind, int text, int max_x, int max_y, unsigned long *werte, unsigned long *max_werte)

{
	float max=0.0;
	int i, h;
	char dummy[35];
	float *prozent;

	h = ob[kind].ob_height;
	prozent = malloc(sizeof(float) * max_x);
	
	if (prozent != NULL) {
		for (i = 0; i < max_x; i++) {
			if (max_werte != NULL) {
				if (max_werte[i] > 0) {
					prozent[i] = ((float )werte[i] / (float)max_werte[i]) * (float )max_y;
				} else {
					prozent[i] = 0;
				}
			} else {
				prozent[i] = (float )werte[i];
			}
			max = MAX(max, prozent[i]);
		}
		for (i = 0; i < max_x; i++) {
			ob[kind + i].ob_spec.obspec.interiorcol = ob[kind + i].ob_spec.obspec.framecol = fill_color[BS_SUMME];
			ob[kind + i].ob_spec.obspec.fillpattern = fill_style[BS_SUMME];

			ob[kind + i].ob_height = (int )((float) h * (prozent[i]) / max);

			if (ob[kind + i].ob_height <= 0) ob[kind + i].ob_height = 1;
			ob[kind + i].ob_y += (h - ob[kind + i].ob_height);

			if (text > 0) {
				itoa((int )prozent[i], dummy, 10);
				if (strlen(dummy) > ob[text + i].ob_spec.tedinfo->te_txtlen) strcpy(ob[text + i].ob_spec.tedinfo->te_ptext, "###");
				else strcpy(ob[text + i].ob_spec.tedinfo->te_ptext, dummy);
			}
		}
		free(prozent);
	}
}


/*----------------------------------------------------------------------
!	Fllt das Formular beginnend mit dem Starteintrag nr. x
+---------------------------------------------------------------------*/

void setze_log(OBJECT *ob, int nr) 

{
	LOG *lg, *ein;
	int i, z, s, m;
	char dummy[20], *c;
	long l;
	DOSTIME dt;
	
	if (log_win->max_y != 10) {	/* noch nicht initialisiert	*/
		log_win->zeilen_anzahl = eintraege;
		log_win->topline = nr = (int )(eintraege - 10);
		log_win->max_y = 10;								/* 10 Zeilen darstellbar!	*/
	}

	for(i = 0, l = 0; l < max_log && i < nr; l++) {
		if (log[l].status == 'S') {
			i++;
		}
	}
	z = i + 1;
	for(i = 0, lg = &log[l]; l < max_log && i < 10; l++, lg++) {
		if (lg->status == 'S') {			/* Start suchen!	*/
			ein = lg;
			intoa(lg->dt.day , dummy, 2);
			intoa(lg->dt.month , &dummy[2], 2);
			intoa(lg->dt.year + 1980 - 1900, &dummy[4], 2);
			intoa(lg->dt.hour , &dummy[6], 2);
			intoa(lg->dt.minute , &dummy[8], 2);
			intoa(lg->dt.second * 2 , &dummy[10], 2);
			
			strcpy(ob[START1 + (i * (START2-START1))].ob_spec.tedinfo->te_ptext, dummy);
			itoa(z++, ob[NR1 + (i * (START2-START1))].ob_spec.tedinfo->te_ptext, 10);
			switch(lg->bs) {
				case 'S':strcpy(ob[BS + (i * (START2-START1))].ob_spec.tedinfo->te_ptext, "S-TOS");break;
				case 'C':strcpy(ob[BS + (i * (START2-START1))].ob_spec.tedinfo->te_ptext, "MagiC");break;
				case 'M':strcpy(ob[BS + (i * (START2-START1))].ob_spec.tedinfo->te_ptext, "MiNT");break;
				case 'N':strcpy(ob[BS + (i * (START2-START1))].ob_spec.tedinfo->te_ptext, "N.AES");break;
				default:*(ob[BS + (i * (START2-START1))].ob_spec.tedinfo->te_ptext) = '\0';break;
			}
			lg++;
			if (++l >= max_log) {
				*(ob[ENDE1 + (i * (START2-START1))].ob_spec.tedinfo->te_ptext) = '\0';
				strcpy(ob[GRUND1 + (i * (START2-START1))].ob_spec.tedinfo->te_ptext, texte[TXT_AKTIV].ob_spec.free_string);

				dt.time = Tgettime();
				dt.date = Tgetdate();
				diff_time(&ein->dt, (DATETIME *)&dt, &s, &m);
				intoa(s, dummy, 4);
				intoa(m, &dummy[4], 2);
				strcpy(ob[DAUER1 + (i * (START2-START1))].ob_spec.tedinfo->te_ptext, dummy);		
			} else if (lg->status != 'S') {
				c = ob[GRUND1 + (i * (START2-START1))].ob_spec.tedinfo->te_ptext;
				switch(lg->status) {
					case 'R':	strcpy(c, texte[TXT_RESCHNG].ob_spec.free_string);	break;
					case 'A':	strcpy(c, texte[TXT_FAULT].ob_spec.free_string);	break;
					case 'E':	if (lg->bs != 'S') strcpy(c, texte[TXT_SHUTDOWN].ob_spec.free_string);
								else strcpy(c, texte[TXT_ABSCHALTEN].ob_spec.free_string);
								break;

				}
				intoa(lg->dt.day , dummy, 2);
				intoa(lg->dt.month , &dummy[2], 2);
				intoa(lg->dt.year + 1980 - 1900, &dummy[4], 2);
				intoa(lg->dt.hour , &dummy[6], 2);
				intoa(lg->dt.minute , &dummy[8], 2);
				intoa(lg->dt.second * 2 , &dummy[10], 2);
				strcpy(ob[ENDE1 + (i * (START2-START1))].ob_spec.tedinfo->te_ptext, dummy);		

				diff_time(&ein->dt, &lg->dt, &s, &m);
				intoa(s, dummy, 4);
				intoa(m, &dummy[4], 2);
				strcpy(ob[DAUER1 + (i * (START2-START1))].ob_spec.tedinfo->te_ptext, dummy);		
			}
			if (++i >= 10) break;	/* nchste Zeile	*/
		}
	}
	for ( ; i < 10; i++) {
		*(ob[START1 + (i * (START2-START1))].ob_spec.tedinfo->te_ptext) = '\0';
		*(ob[ENDE1 + (i * (START2-START1))].ob_spec.tedinfo->te_ptext) = '\0';
		*(ob[GRUND1 + (i * (START2-START1))].ob_spec.tedinfo->te_ptext) = '\0';
		*(ob[DAUER1 + (i * (START2-START1))].ob_spec.tedinfo->te_ptext) = '\0';
		*(ob[NR1 + (i * (START2-START1))].ob_spec.tedinfo->te_ptext) = '\0';
	}
}

/*----------------------------------------------------------------------
!	Speichert die LOG-Datei unter dem angegebenen Dateinamen ab
+---------------------------------------------------------------------*/

void speicher_log(void) 

{
	LOG *lg, *ein;
	int s, m, i;
	char *c;
	DOSTIME dt;
	
	int fd;
	long l;
	char line[120], path[128]="*.csv", file[128]="";
	
	fsel_exinput( path, file, &i, "Speichern unter");
	
	if (i == 0) return;
	c = strrchr(path, '\\');
	if (c != NULL) *(++c) = '\0';
	strcpy(c, file);
	
	l = Fcreate(path, 0);
	if (l < 0) return;
	fd = (int )l;
	Fwrite(fd, 69, "\"Startdatum\",\"Startzeit\",\"Endedatum\",\"Endezeit\",\"Dauer\",\"Endegrund\"\r\n");
	for(l = 0, lg = log; l < max_log; l++, lg++) {
		if (lg->status == 'S') {			/* Start suchen!	*/
			ein = lg;
			c = line;
			intoa(lg->dt.day , c, 2);
			c+=2;
			*c++ = '.';
			intoa(lg->dt.month , c, 2);
			c+=2;
			*c++ = '.';
			intoa(lg->dt.year + 1980 , c, 4);
			c+=4;
			*c++ = ',';
			intoa(lg->dt.hour , c, 2);
			c+=2;
			*c++ = ':';
			intoa(lg->dt.minute , c, 2);
			c+=2;
			*c++ = ':';
			intoa(lg->dt.second * 2 , c, 2);
			c+=2;
			*c++ = ',';
			lg++;
			if (++l >= max_log) {
				dt.time = Tgettime();
				dt.date = Tgetdate();
				diff_time(&ein->dt, (DATETIME *)&dt, &s, &m);
				strcpy(c, ",,");
				c+=2;
				intoa(s, c, 4);
				c+=4;
				*c++=':';
				intoa(m, c, 2);
				strcat(c, ",\"");
				strcat(c, texte[TXT_AKTIV].ob_spec.free_string);
				strcat(c, "\"\r\n");
			} else if (lg->status != 'S') {
				intoa(lg->dt.day , c, 2);
				c+=2;
				*c++ = '.';
				intoa(lg->dt.month , c, 2);
				c+=2;
				*c++ = '.';
				intoa(lg->dt.year + 1980 , c, 4);
				c+=4;
				*c++ = ',';
				intoa(lg->dt.hour , c, 2);
				c+=2;
				*c++ = ':';
				intoa(lg->dt.minute , c, 2);
				c+=2;
				*c++ = ':';
				intoa(lg->dt.second * 2 , c, 2);
				c+=2;
				*c++ = ',';
				diff_time(&ein->dt, &lg->dt, &s, &m);
				intoa(s, c, 4);
				c+=4;
				*c++=':';
				intoa(m, c, 2);
				strcat(c, ",\"");
				switch(lg->status) {
					case 'R':	strcat(c, texte[TXT_RESCHNG].ob_spec.free_string);	break;
					case 'A':	strcat(c, texte[TXT_FAULT].ob_spec.free_string);		break;
					case 'E':	strcat(c, texte[TXT_SHUTDOWN].ob_spec.free_string);		break;
				}
				strcat(c, "\"\r\n");
			}
			Fwrite(fd, strlen(line), line);
		}
	}
	Fclose(fd);
}

/*------------------------------------------------------------------------
!	intoa
!	Wandelt eine Integer in einen Ascii-String um. Es kann angegeben erden, wie
!	lang der String sein soll
+-------------------------------------------------------------------------*/

char *intoa(int value, char *string, int laenge)

{
	char *c;

	c = &string[laenge];
	*(c--) = '\0';
	while (c >= string) {
		*(c--) = (value % 10) + '0';
		value /= 10;
	}
	
	return(string);
}

/*-------------------------------------------------------------------------
!	Berechnet die Differenz zwischen zwei DATETIME-Strukturen
!	Die Werte Minuten und Stunden werden gesetzt
!	Summe wird als Sekunden zurckgegeben
+------------------------------------------------------------------------*/

long diff_time(DATETIME *start, DATETIME *ende, int *stunden, int *minuten)

{
	time_t diff, l;
	
	diff = get_sekunden(ende) - get_sekunden(start);

	if (diff < 0L) diff = 0L;
	
	l = diff / 60;				/* Minuten errechnen	*/
	*minuten = (int )(l % 60);	/* Aufteilen in Minuten und Stunden	*/
	*stunden = (int )(l / 60);
	return(diff);
}

/*--------------------------------------------------------------------
!	Setzt die Statistikwerte
+-------------------------------------------------------------------*/

void setze_statistik(OBJECT *ob)

{
	char *c;
	LOG *l;
	int i;
	
	if (max_log <= 0) return;
	
	c = ob[ANFANG].ob_spec.tedinfo->te_ptext;
	for(l = log, i = 0; i < max_log && l->status != 'S'; i++, l++);
	intoa(l->dt.day , c, 2);
	intoa(l->dt.month , &c[2], 2);
	intoa(l->dt.year + 1980 , &c[4], 4);
	
	ltoa((bs_stat[BS_SUMME].betriebssekunden / 3600), ob[STUNDEN].ob_spec.tedinfo->te_ptext, 10);

	setze_stat(ob_stat_h, NULL_UHR, ANZ_STUNDEN, 24, 60, bs_stat[BS_SUMME].stat_h, stat_h_max);
	if (color == 1) for (i = H_LINE; i < H_LINE + 6; ob_stat_h[i++].ob_spec.obspec.framesize = 0);

	setze_stat(ob_stat_w, MONTAG, ANZ_TAGE, 7, 24, bs_stat[BS_SUMME].stat_w, stat_w_max);
	if (color == 1) for (i = W_LINE; i < W_LINE + 6; ob_stat_w[i++].ob_spec.obspec.framesize = 0);

	setze_stat(ob_stat_m, JANUAR, ANZ_MONAT, 12, 24, bs_stat[BS_SUMME].stat_m, stat_m_max);
	if (color == 1) for (i = M_LINE; i < M_LINE + 6; ob_stat_m[i++].ob_spec.obspec.framesize = 0);

	setze_stat(ob_stat_e, ABSTURZ, ANZ_ABSTURZ, 3, 1, bs_stat[BS_SUMME].stat_e, NULL);
	if (color == 1) for (i = E_LINE; i < E_LINE + 6; ob_stat_e[i++].ob_spec.obspec.framesize = 0);

	setze_stat(ob_stat_d, UNTER1MIN, ANZ_DAUER, 12, 1, bs_stat[BS_SUMME].stat_d, NULL);
	if (color == 1) for (i = D_LINE; i < D_LINE + 6; ob_stat_d[i++].ob_spec.obspec.framesize = 0);
}

void set_style(void) 
{
	int i;
	
	for (i = NULL_UHR; i < 24+NULL_UHR; i++) { 
		ob_stat_h[i].ob_spec.obspec.fillpattern = fill_style[BS_SUMME];
		ob_stat_h[i].ob_spec.obspec.interiorcol = ob_stat_h[i].ob_spec.obspec.framecol = fill_color[BS_SUMME];
	}
	for (i = MONTAG; i < 7+MONTAG; i++) { 
		ob_stat_w[i].ob_spec.obspec.fillpattern = fill_style[BS_SUMME];
		ob_stat_w[i].ob_spec.obspec.interiorcol = ob_stat_w[i].ob_spec.obspec.framecol = fill_color[BS_SUMME];
	}
	for (i = JANUAR; i < 12+JANUAR; i++) { 
		ob_stat_m[i].ob_spec.obspec.fillpattern = fill_style[BS_SUMME];
		ob_stat_m[i].ob_spec.obspec.interiorcol = ob_stat_m[i].ob_spec.obspec.framecol = fill_color[BS_SUMME];
	}
	for (i = ABSTURZ; i < 3+ABSTURZ; i++) { 
		ob_stat_e[i].ob_spec.obspec.fillpattern = fill_style[BS_SUMME];
		ob_stat_e[i].ob_spec.obspec.interiorcol = ob_stat_e[i].ob_spec.obspec.framecol = fill_color[BS_SUMME];
	}
	for (i = UNTER1MIN; i < 12+UNTER1MIN; i++) { 
		ob_stat_d[i].ob_spec.obspec.fillpattern = fill_style[BS_SUMME];
		ob_stat_d[i].ob_spec.obspec.interiorcol = ob_stat_d[i].ob_spec.obspec.framecol = fill_color[BS_SUMME];
	}
}

/*------------------------------------------------------------------------
!	Ldt die Infodatei und stellt die Fenster ein!
!	wenn alles = FALSE, dann werden nu die Fensterpositionen geladen!
+-----------------------------------------------------------------------*/

void lese_inf(void)

{
	char inf_file[]="SEEBAER.INF";
	char *buffer, *c;
	char *name, *x, *y, *w, *h, *f, *e;
	int fd;
	long l;
	
	l = Fopen(inf_file, FO_READ);
	if (l > 0) {
		fd = (int )l;
		l = Fseek(0, fd, 2);	/* Lnge feststellen	*/
		Fseek(0, fd, 0);		/* Aber von Anfang an lesen	*/
		buffer = malloc(l+1);
		if (buffer != NULL) {
			Fread(fd, l, buffer);
			buffer[l] = '\0';
			c = e = buffer;
			while (e != NULL && *c != '\0') {
				events(TRUE);	/* Nachrichten abarbeiten!	*/
				e = strstr(c, "\r\n");
				if (e != NULL) *e = '\0';
				name = strtok(c, " \t");
				x = strtok(NULL, " \t");
				y = strtok(NULL, " \t");
				w = strtok(NULL, " \t");
				h = strtok(NULL, " \t");
				f = strtok(NULL, " \t");

				if (stricmp(name, "Fillstyle:") == 0)		{ 
					fill_style[0] = (x != NULL) ? atoi(x) : 7; 
					fill_style[1] = (y != NULL) ? atoi(y) : 7; 
					fill_style[2] = (w != NULL) ? atoi(w) : 7; 
					fill_style[3] = (h != NULL) ? atoi(h) : 7; 
					fill_style[4] = (f != NULL) ? atoi(f) : 7; 
					set_style();
				} else if (stricmp(name, "Fillcolor:") == 0)	{
					fill_color[0] = (x != NULL) ? atoi(x) : 2;
					fill_color[1] = (y != NULL) ? atoi(y) : 2; 
					fill_color[2] = (w != NULL) ? atoi(w) : 2; 
					fill_color[3] = (h != NULL) ? atoi(h) : 2; 
					fill_color[4] = (f != NULL) ? atoi(f) : 2; 
					set_style();
				} else if (stricmp(name, "Textcolor:") == 0)	{
					text_color[0] = (x != NULL) ? atoi(x) : 1;
					text_color[1] = (y != NULL) ? atoi(y) : 1; 
					text_color[2] = (w != NULL) ? atoi(w) : 1; 
					text_color[3] = (h != NULL) ? atoi(h) : 1; 
					text_color[4] = (f != NULL) ? atoi(f) : 1; 
					set_style();
				}

				else if (stricmp(name, "MinBreite:") == 0)	min_breite = atoi(x);
				else if (stricmp(name, "ShutStat:") == 0)	oeffne_form(STAT_ENDE, texte[TXT_SE_TITEL].ob_spec.free_string, texte[TXT_SE_INFO].ob_spec.free_string, "ShutStat", 0L, atoi(x), atoi(y));
				else if (stricmp(name, "LaufStat:") == 0)	oeffne_form(STAT_DAUER, texte[TXT_SD_TITEL].ob_spec.free_string, texte[TXT_SD_INFO].ob_spec.free_string, "LaufStat", 0L, atoi(x), atoi(y));
				else if (stricmp(name, "StdStat:") == 0)	oeffne_form(STAT_H, texte[TXT_SH_TITEL].ob_spec.free_string, texte[TXT_SH_INFO].ob_spec.free_string, "StdStat", 0L, atoi(x), atoi(y));
				else if (stricmp(name, "WochStat:") == 0)	oeffne_form(STAT_W, texte[TXT_SW_TITEL].ob_spec.free_string, texte[TXT_SW_INFO].ob_spec.free_string, "WochStat", 0L, atoi(x), atoi(y));
				else if (stricmp(name, "MonStat:") == 0)	oeffne_form(STAT_M, texte[TXT_SM_TITEL].ob_spec.free_string, texte[TXT_SM_INFO].ob_spec.free_string, "MonStat", 0L, atoi(x), atoi(y));
				else if (stricmp(name, "Titel:") == 0)		oeffne_form(COPYRIGHT, TITEL, NULL, "Titel", 0L, atoi(x), atoi(y));

				else if (stricmp(name, "LogFile:") == 0) {
					log_win = oeffne_form(LOG_INFO, texte[TXT_LOG_TITEL].ob_spec.free_string, texte[TXT_LOG_INFO].ob_spec.free_string, "LogFile", 0L, atoi(x), atoi(y));
					log_win->topline = log_win->zeilen_anzahl - log_win->max_y;
					if (log_win->topline < 0) log_win->topline = 0;
				} else if (stricmp(name, "fortTag:") == 0) {
					ft = oeffne_balken(texte[TXT_FT_TITEL].ob_spec.free_string, texte[TXT_FT_INFO].ob_spec.free_string, "fortTag", anz_ft, atoi(x), atoi(y), atoi(w), atoi(h));
				} else if (stricmp(name, "fortWoch:") == 0) {
					fw = oeffne_balken(texte[TXT_FW_TITEL].ob_spec.free_string, texte[TXT_FW_INFO].ob_spec.free_string, "fortWoch", anz_fw, atoi(x), atoi(y), atoi(w), atoi(h));
				} else if (stricmp(name, "fortMon:") == 0) {
					fm = oeffne_balken(texte[TXT_FM_TITEL].ob_spec.free_string, texte[TXT_FM_INFO].ob_spec.free_string, "fortMon", anz_fm, atoi(x), atoi(y), atoi(w), atoi(h));
				} else if (stricmp(name, "BetrDau:") == 0) {
					if (bds == NULL) bds = create_fenster(texte[TXT_BD_TITEL].ob_spec.free_string, texte[TXT_BD_INFO].ob_spec.free_string , "BetrDau", NULL);
					if (bds != NULL) oeffne_fenster(bds, atoi(x), atoi(y), atoi(w), atoi(h));
				}

				if (e != NULL) c = &e[2];
			}
			free(buffer);
		}
		Fclose(fd);
	}
}


/*-----------------------------------------------------------------------
!	ffnet ein Balkenfenster
+------------------------------------------------------------------------*/

FENSTER *oeffne_balken(char *titel, char *info, char *inf_file, long anzahl, int x, int y, int w, int h)

{
	FENSTER *win;

	win = create_fenster(titel, info, inf_file, NULL);
	if (win != NULL) {
		oeffne_fenster(win, x, y, w, h);
		win->max_x = win->aw / min_breite;
		win->spalten_anzahl = anzahl;
		win->leftpos = win->spalten_anzahl - win->max_x;
		if (win->leftpos < 0) win->leftpos = 0;
	}
	return(win);
}

/*---------------------------------------------------------------------
!	Sucht das Ende eines Strings
+-------------------------------------------------------------------*/

void ende(char *text, char e)

{
	char *c;
	if (text != NULL) {
		c = strchr(text, e);
		if (c != NULL) *c = '\0';
	}
}

/*--------------------------------------------------------------------
!	Speichert eine SEEBAER.INF Datei, in der die Fensterpositionen
!	gesichert werden:
+------------------------------------------------------------------------*/

void sichern_inf(void)

{
	char inf_file[]="SEEBAER.INF";
	char buffer[256];
	int fd, i;
	long l;
	FENSTER *w;
	
	l = Fcreate(inf_file, 0);
	if (l > 0) {
		fd = (int )l;
		strcpy(buffer, "Fillcolor: ");
		for (i = 0; i <= BS_UNBEK; i++) {
			itoa(fill_color[i], &buffer[strlen(buffer)], 10);
			strcat(buffer, " ");
		}
		strcat(buffer, "\r\nFillstyle: ");
		for (i = 0; i <= BS_UNBEK; i++) {
			itoa(fill_style[i], &buffer[strlen(buffer)], 10);
			strcat(buffer, " ");
		}
		strcat(buffer, "\r\nTextcolor: ");
		for (i = 0; i <= BS_UNBEK; i++) {
			itoa(text_color[i], &buffer[strlen(buffer)], 10);
			strcat(buffer, " ");
		}
		strcat(buffer, "\r\nMinBreite: ");
		itoa(min_breite, &buffer[strlen(buffer)], 10);
		strcat(buffer, "\r\n");
		Fwrite(fd, strlen(buffer), buffer);
		for (w = main_window; w != NULL; w = w->next) {
			if (*w->inf == '\0') continue;
			strcpy(buffer, w->inf);
			strcat(buffer, ": ");
			itoa(w->fx, &buffer[strlen(buffer)], 10);
			strcat(buffer, " ");
			itoa(w->fy, &buffer[strlen(buffer)], 10);
			if (w->ob == NULL) {
				strcat(buffer, " ");
				itoa(w->fw, &buffer[strlen(buffer)], 10);
				strcat(buffer, " ");
				itoa(w->fh, &buffer[strlen(buffer)], 10);
			}
			strcat(buffer, "\r\n");
			Fwrite(fd, strlen(buffer), buffer);
		}
		Fclose(fd);
	}
}

/*-------------------------------------------------------------------------
!	Berechnet die Anzahl der Tage seit 1980
+------------------------------------------------------------------------*/

int get_tage(DATETIME *dt)

{
    int jahr, i, leap, day;                                /* Wieder mal n' Haufen Variablen, sind nur fr die momentane Routine ntzlich  */

    jahr = dt->year + 1980;   						   /* und das Jahr seit 1980! Also daher das Ergebnis + 1980!                      */

    for(i = 1980, day = 0; i < jahr; i++) {                         /* Zhlen wir die Tage seit dem 1.1.1980 (das war ein Diensttag!)               */
    	leap = (i%4 == 0 && i%100 != 0 || i%400 == 0);              /* Wir gehen alle Jahre bis heute durch und stellen fest welches Jahr ein       */
        day += day_tab[leap][0];                                    /* Schaltjahr ist. Davon abhngig wird die entsprechende Anzahl an Tagen addiert*/
    }
    leap = (jahr%4 == 0 && jahr%100 != 0 || jahr%400 == 0);         /* Jetzt men wir uns die Monate genauer anschauen. Schaltjahr?                */
    for(i = 1; i < dt->month; i++) day += day_tab[leap][i];         /* Wert entsprechend obiger Tabelle addieren                                    */
    day += dt->day;                                                 /* Tja und am Schlu noch den aktuellen Tag addieren                            */
	return(day);
}

/*----------------------------------------------------------------------------
!	Berechnet die Sekunden seit 1980
+---------------------------------------------------------------------------*/

long get_sekunden(DATETIME *dt)

{
	long sek;
	
	sek = (long )get_tage(dt) * 86400L;	/* Anzahl der Sekunden seit 1.1.1980	*/
	sek += (long )(dt->hour * 3600L) + (long )(dt->minute * 60L) + (long )(dt->second * 2L);
	
	return(sek);
}
