/*---------------------------------------------------------------
!	Dieses Programm mu in den Start-Ordner.
!	Es legt die Log-Buch-Datei an und wertet
!	den Timestamp der Datei aus.
!	Ist der Timestamp der Datei lter, als der
!	letzte STOP-Eintrag, dann ist der Rechner abgestrzt
+--------------------------------------------------------------*/

#include <tos.h>
#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <aes.h>
#include <new_aes.h>
#include <magx.h>

#define TRUE 1
#define FALSE 0

long intervall=300000L;	/* 5 Minuten Intervall	*/

typedef struct {
	char cookie[4];
	long value;
} MY_COOKIE;

typedef struct {
	DOSTIME dt;
	char status;		/* 'S' = Start; 'E' = Ende; 'A' = Absturz	*/
	char bs;			/* Multitos='M', N.AES='N', SingleTOS='S', MagiC='C'	*/
} LOG;

unsigned long last;
char bs=' ';

void touch(char *file);
void start(char *file);
void stop(char *file, char status);
int test_cookie(char *cookie, long *value);

void main(void)

{
	char proto_file[128], *c[];
	int buffer[16], i, erg;
	int app_nr, quit;
	
	if (Pdomain(1) >= 0) {	/* Lange Dateinamen verarbeiten	*/
		shel_write(SHW_MSGREC, 0x0001, 0, NULL, NULL);	/* Ich verstehe AP_TERM	*/
	}

	shel_envrn(c, "SEEBAER-FILE=");
	
	if (test_cookie("MiNT", NULL)) bs = 'M';
	if (test_cookie("nAES", NULL)) bs = 'N';
	if (test_cookie("MagX", NULL)) bs = 'C';
	else {
		bs = 'S';
		intervall = 60000L;	/* bei SingleTOS nur 1 Minute!	*/
	}
	
	if (*c != NULL) strcpy(proto_file, *c);
	else strcpy(proto_file, "C:\\SEEBAER.LOG");
	
	app_nr = appl_init();
	start(proto_file);			/* Absturz oder normaler Start?		*/

	if (app_nr >= 0) {
		quit = FALSE;
		do {
			erg = evnt_multi(MU_MESAG | MU_TIMER, 0,0,0,0,0,0,0,0,0,0,0,0,0,
							buffer, intervall & 0xFFFF, intervall >> 16,
							&i,&i,&i,&i,&i,&i);
							
			touch(proto_file);

			if (erg & MU_MESAG) {
				if (buffer[0] == AP_TERM) {
					if (buffer[5] == AP_TERM) stop(proto_file, 'E');
					else if (buffer[5] == AP_RESCHG) stop(proto_file, 'R');
					quit = TRUE;
				}
			}
		} while (!quit);
		appl_exit();
	}
	return;
}

/*--------------------------------------------------------------
!	ndert das Filedatum der Datei
+-----------------------------------------------------------*/

void touch(char *file)

{
	int fd;
	long l;
	DOSTIME dt;
	
	dt.time = Tgettime();
	dt.date = Tgetdate();
	l = Fopen(file, FO_READ);
	if (l > 0) {
		fd = (int )l;
		Fdatime(&dt , fd, TRUE);
		Fclose(fd);
	}
}

/*-----------------------------------------------------------------
!	Prft,ob das Filedate der Datei <= dem letzten Einrag ist.
!	Ist das nicht der Fall, wird ein Absturzdaum eingetragen
!	Das Startdatum wird auch gleich eingetragen
+----------------------------------------------------------------*/

void start(char *file)

{
	int fd;
	long l;
	unsigned long z;
	DOSTIME dt;
	LOG log;
	
	l = Fopen(file, FO_RW);
	if (l == -33) {					/* Datei nicht vorhanden	*/
		l = Fcreate(file, 0);		/* dann neu anlegen			*/
	}
	if (l > 0) {
		fd = (int )l;
		Fdatime(&dt , fd, FALSE);
		
		Fseek(sizeof(LOG) * -1, fd, 2);	/* auf den letzten Datensatz positionieren	*/
		l = Fread(fd, sizeof(LOG), &log);

		if (l > 0) {	/* Testen, ob atuelle Uhrzeit grer als eingetragene Zeit ist!	*/
			z = ((long )Tgetdate() << 16) + Tgettime();
			last = ((long )log.dt.date << 16) + log.dt.time;
			if (last > z) {/* Problem! Uhrzeit < letztem Eintrag!	*/
				Fclose(fd);
				form_alert(1,"[3][Systemuhrzeit falsch!| |Systemtime wrong!][Cancel Log]");
				if (_app) {
					appl_exit();
					exit(0);
					return;	
				}
			}
		}

		if (l > 0 && log.status == 'S') {	/* keine neue Datei und letzter Eintrag keine Start-kennung!	*/
			if (log.bs == 'S') log.status = 'E';	/* Unter SingleTOS gibts keinen Absturz	*/
			else log.status = 'A';		/* Absturz!	*/
			if ((dt.date > log.dt.date) || 
				((dt.date == log.dt.date) && (dt.time > log.dt.time))) {
				log.dt.date = dt.date;
				log.dt.time = dt.time;
			}
			Fwrite(fd, sizeof(LOG), &log);
		}

		log.bs = bs;		
		log.status = 'S';		/* Normaler Start immer schreiben	*/
		log.dt.date = Tgetdate();
		log.dt.time = Tgettime();
		Fwrite(fd, sizeof(LOG), &log);
		
		Fclose(fd);
	}
}

/*-----------------------------------------------------------------
!	Das Endedatum wid mit 'status' eingetragen
+----------------------------------------------------------------*/

void stop(char *file, char status)

{
	int fd;
	long l;
	LOG log;
	
	l = Fopen(file, FO_RW);
	if (l > 0) {
		fd = (int )l;
		Fseek(0, fd, 2);	/* auf das Dateiende positionieren	*/
		
		log.bs = bs;
		log.status = status;
		log.dt.date = Tgetdate();
		log.dt.time = Tgettime();
		if (((long )log.dt.date << 16) + log.dt.time < last) {
			form_alert(1,"[3][Systemuhrzeit falsch!| |Systemtime wrong!][Cancel Log]");
		} else {
			last = ((long )log.dt.date << 16) + log.dt.time;
			Fwrite(fd, sizeof(LOG), &log);
		}
		
		Fclose(fd);
	}
}

/*-----------------------------------------------------------------------
!	berprft, ob der cookie "text" vorhanden ist.
+----------------------------------------------------------------------*/

int test_cookie(char *cookie, long *value)

{
	void *ssp;
	MY_COOKIE *cook_ptr;
	
	ssp = (void *)Super(0);

	cook_ptr = *(MY_COOKIE **)0x5A0;		/* cookie Speicherplatzzeiger	*/
	
	Super(ssp);

	if (cook_ptr != NULL) {
		do {
			if (strncmp(cook_ptr->cookie, cookie, 4) == 0) {
				if (value != NULL) *value = cook_ptr->value;
				return(TRUE);
			}
		} while (memcmp((cook_ptr++)->cookie, "\0\0\0\0", 4) != 0);
	}	
	return(FALSE);
}
